﻿class MakeInterface
{
	static public var originalStageWidth:Number = 512;
	static public var originalStageHeight:Number = 512;

	//dire si on est en mode photo ou diaporama : 0 = vignette, 1 = diaporama
	static public var modeScene:Number = 0;

	static private var currentIdVignette:Number = 0; //id de la vignette qui est affichee
	static private var marge:Number = 10; //marge por l'affichage
	
	//dimentions de la barre de controle (calcule manuellement!!)
	static private var barreWidth:Number = 211;
	static private var barreHeight:Number = 76;
	
	static private var imgFileRoot:String; //emplacement des images pour l'interface
	
	static private var afficherImageLoadMask:MovieClip; //masque necessaire pour les animations du chargement de l'image (depth = 3001)
	static private var afficherImageLoadProgressContainer:MovieClip; //movieClip qui contient l'animation de la barre de progression (depth = 3002)

	private var afficherImg:MovieClip;
	private var BDownload:MovieClip;
	private var BBack:MovieClip;
	private var BNext:MovieClip;
	private var BQuitterDiaporama:MovieClip;
	
	function MakeInterface(rootHttp:String, interfaceImageFolder:String, myXMLzip:XMLNode)
	{
		MakeInterface.imgFileRoot = rootHttp+interfaceImageFolder;
		
		var functionOnPress:Function = new Function();
		
		//creer le movieclip qui affiche les images
		afficherImg = _root.createEmptyMovieClip("afficherImg", 3000);
		afficherImg._x = 800;
		afficherImg._y = 100;
		
		//creer bouton telecharger le zip
		if(myXMLzip != null)
		{
			functionOnPress = function()
			{
				getURL(rootHttp+myXMLzip.attributes.filepath, "_blank");
			};
			
			createButton(BDownload, "BDownload", _root, functionOnPress, 3003);
		}
		
		//creer le bouton pour voir la diapo precedente
		functionOnPress = function()
		{
			var id = MakeInterface.currentIdVignette - 1;
			if(id == -1) id = Vignette.vignetteArray.length - 1;
			MakeInterface.chargerImage(id);
		};
		
		createButton(BBack, "BBack", _root, functionOnPress, 3005);
		
		//creer le bouton pour voir la diapo suivante
		functionOnPress = function()
		{
			var id = MakeInterface.currentIdVignette + 1;
			if(id == Vignette.vignetteArray.length) id = 0;
			MakeInterface.chargerImage(id);
		};
		
		createButton(BNext, "BNext", _root, functionOnPress, 3006);
		
		//creer le bouton pour quitter le diaporama
		functionOnPress = function()
		{
			MakeInterface.modeScene = 0;
			ajusterInterface(Stage.width, Stage.height);
		};
		
		createButton(BQuitterDiaporama, "BQuitterDiaporama", _root, functionOnPress, 3007, 900, 50);
	}
	
	private function createButton(buttonClip:MovieClip, buttonString:String, parent:MovieClip, OnPressFunction:Function, depth:Number)
	{
		var loaderListener:Object = new Object();
		var loadImage:MovieClipLoader = new MovieClipLoader();
		
		buttonClip = parent.createEmptyMovieClip(buttonString, depth);
		
		//lorsque le chargement est fini
		loaderListener.onLoadInit = function(holderClip:MovieClip):Void
		{
			buttonClip.onPress = OnPressFunction;
			
			loadImage.removeListener(loaderListener);
		};
		
		loadImage.addListener(loaderListener);
		loadImage.loadClip(MakeInterface.imgFileRoot+"/"+buttonString+".png", buttonClip);
	}
	
	static public function chargerImage(id:Number)
	{
		var afficherImageLoadProgress:MovieClip; //progression du chargement de l'image
		var afficherImageLoadBackground:MovieClip; //fond de chargement
		
		//mettre a jour l'id de la vignette qui est chargee dans le diaporama
		MakeInterface.currentIdVignette = id;
		
		//regardee si l'image est deja en cache ou non
		if(Vignette.vignetteArray[id].imageEstChargee == true)
		{
			//si oui, charger directement l'image
			var directLoaderListener:Object = new Object();
			var directLoadImage:MovieClipLoader  = new MovieClipLoader();
			
			//on retire l'enventuelle barre de chargement d'une autre image qui etait en train de charger
			_root.afficherImageLoadProgressContainer.afficherImageLoadBackground.removeMovieClip();
			_root.afficherImageLoadProgressContainer.afficherImageLoadProgress.onEnterFrame = undefined;
			_root.afficherImageLoadProgressContainer.afficherImageLoadProgress.removeMovieClip();
			_root.afficherImageLoadMask.removeMovieClip();
			_root.afficherImageLoadProgressContainer.removeMovieClip();
			
			//mettre sur le mode diaporama
			MakeInterface.ajusterInterface(Stage.width, Stage.height);
			
			//lorsque le chargement est fini
			directLoaderListener.onLoadInit = function(holderClip:MovieClip):Void
			{
				//redimentionner l'image pour qu'elle apparaisse sur toute la fenetre
				MakeInterface.redimentionnerImageFenetre(Stage.width, Stage.height);
				
				directLoadImage.removeListener(directLoaderListener);
			};
			
			directLoadImage.addListener(directLoaderListener);
			directLoadImage.loadClip(Vignette.vignetteArray[id].imageSrc, _root.afficherImg);
		}
		else
		{
			//si non, on cree l'animation de chargement
		
			//on cree le masque du movieClip imageLoad
			afficherImageLoadMask = _root.createEmptyMovieClip("afficherImageLoadMask", 3001);
			
			//creer le movieClip qui contient l'animation de la barre de progression
			afficherImageLoadProgressContainer = _root.createEmptyMovieClip("afficherImageLoadProgressContainer", 3002);
			
			//creer l'image de progression du chargement de l'image
			afficherImageLoadProgress = afficherImageLoadProgressContainer.createEmptyMovieClip("afficherImageLoadProgress", 0);
			
			//creer l'image de fond du chargement de l'image
			afficherImageLoadBackground = afficherImageLoadProgressContainer.createEmptyMovieClip("afficherImageLoadBackground", 1);
			
			//mettre sur le mode diaporama
			MakeInterface.ajusterInterface(Stage.width, Stage.height);
			
			//on charge la barre de fond de chargement
			var backgroundLoaderListener:Object = new Object();
			var backgroundLoadImage:MovieClipLoader  = new MovieClipLoader();
			
			//lorsque le chargement est fini
			backgroundLoaderListener.onLoadInit = function(holderClip:MovieClip):Void
			{
				//on applique le masque de taille 200x16 sur le moviclip qui contient la barre d'animation et qui est a la taille de l'icone
				_root.afficherImageLoadMask.beginFill(0x000000, 100);
				_root.afficherImageLoadMask.moveTo(0 , 0);
				_root.afficherImageLoadMask.lineTo(200, 0);
				_root.afficherImageLoadMask.lineTo(200, 16);
				_root.afficherImageLoadMask.lineTo(0 , 16);
				_root.afficherImageLoadMask.endFill();
				
				_root.afficherImageLoadProgressContainer.setMask(_root.afficherImageLoadMask);
				
				//on charge la barre de progression
				var progressLoaderListener:Object = new Object();
				var progressLoadImage:MovieClipLoader  = new MovieClipLoader();
				
				//lorsque le chargement est fini
				progressLoaderListener.onLoadInit = function(holderClip:MovieClip):Void
				{
					//on cree l'animation de la barre
					_root.afficherImageLoadProgressContainer.afficherImageLoadProgress.onEnterFrame = function()
					{
						_root.afficherImageLoadProgressContainer.afficherImageLoadProgress._x --;
						if(_root.afficherImageLoadProgressContainer.afficherImageLoadProgress._x <= -16) _root.afficherImageLoadProgressContainer.afficherImageLoadProgress._x = 0;
					}
					
					//on charge l'image
					var loaderListener:Object = new Object()
					var loadImage:MovieClipLoader  = new MovieClipLoader();
					
					//mettre a jour les donnees
					loaderListener.onLoadProgress = function(holderClip:MovieClip, loadedBytes:Number, totalBytes:Number):Void
					{
						var percent:Number = loadedBytes / totalBytes;
						_root.afficherImageLoadProgressContainer.afficherImageLoadBackground._x = Math.round(percent * 200);
					};
					
					//lorsque le chargement est fini
					loaderListener.onLoadInit = function(holderClip:MovieClip):Void
					{
						//on retire l'animation de chargement de l'image
						_root.afficherImageLoadProgressContainer.afficherImageLoadBackground.removeMovieClip();
						_root.afficherImageLoadProgressContainer.afficherImageLoadProgress.onEnterFrame = undefined;
						_root.afficherImageLoadProgressContainer.afficherImageLoadProgress.removeMovieClip();
						_root.afficherImageLoadMask.removeMovieClip();
						_root.afficherImageLoadProgressContainer.removeMovieClip();
						
						//on indique que l'image est bien chargee en cache
						Vignette.vignetteArray[id].imageEstChargee = true;
						
						//comme l'image de l'icone est chargee, alors on met l'alpha de l'icone a 100%
						Vignette.vignetteArray[id].mc._alpha = 100;
						
						//redimentionner l'image pour qu'elle apparaisse sur toute la fenetre
						MakeInterface.redimentionnerImageFenetre(Stage.width, Stage.height)
						
						loadImage.removeListener(loaderListener);
					};
					
					loadImage.addListener(loaderListener);
					loadImage.loadClip(Vignette.vignetteArray[id].imageSrc, _root.afficherImg);
					
					progressLoadImage.removeListener(progressLoaderListener);
				};
				
				progressLoadImage.addListener(progressLoaderListener);
				progressLoadImage.loadClip(MakeInterface.imgFileRoot+"/bigProgressBar2.png", _root.afficherImageLoadProgressContainer.afficherImageLoadProgress);
				
				backgroundLoadImage.removeListener(backgroundLoaderListener);
			};
			
			backgroundLoadImage.addListener(backgroundLoaderListener);
			backgroundLoadImage.loadClip(MakeInterface.imgFileRoot+"/bigProgressBar1.png", _root.afficherImageLoadProgressContainer.afficherImageLoadBackground);
		}
	}
	
	static public function positionRefX(stageWidth:Number):Number
	{
		var positionRefX:Number;
		
		//definir la reference : corriger le deplacement pour placer en haut a gauche
		positionRefX = Math.round((MakeInterface.originalStageWidth - stageWidth)/2);
		
		//la position est une fenetre plus loin a droite
		positionRefX += stageWidth;
		
		//la position depend du mode
		positionRefX -= stageWidth * MakeInterface.modeScene;
		
		return positionRefX;
	}
	
	static public function positionRefY(stageHeight:Number):Number
	{
		var positionRefY:Number;
		
		//definir la reference : corriger le deplacement pour placer en haut a gauche
		positionRefY = Math.round((MakeInterface.originalStageHeight - stageHeight)/2);
		
		return positionRefY;
	}
	
	static public function ajusterInterface(stageWidth:Number, stageHeight:Number)
	{
		//ajuster les vignettes
		Vignette.ajusterIcones(stageWidth, stageHeight);
		
		//position de reference
		var positionRefX:Number = MakeInterface.positionRefX(stageWidth);
		var positionRefY:Number = MakeInterface.positionRefY(stageHeight);
		
		//position de la barre de chargement
		var barreLoadX:Number;
		var barreLoadY:Number;
		
		//position de la barre
		var barreX:Number;
		var barreY:Number;
		
		//redimentionner l'image pour qu'elle apparaisse sur toute la fenetre
		MakeInterface.redimentionnerImageFenetre(stageWidth, stageHeight);
		
		//placement de la barre de chargement de taille 200x16
		barreLoadX = positionRefX + Math.round((stageWidth - 200)/2);
		barreLoadY = positionRefY + Math.round((stageHeight - MakeInterface.barreHeight - MakeInterface.marge - 16)/2);
		_root.afficherImageLoadProgressContainer._x = barreLoadX;
		_root.afficherImageLoadProgressContainer._y = barreLoadY;
		
		//placement du masque de la barre de chargement
		_root.afficherImageLoadMask._x = barreLoadX;
		_root.afficherImageLoadMask._y = barreLoadY;
		
		//placement de la barre
		barreX = positionRefX + Math.round((stageWidth - MakeInterface.barreWidth)/2);
		barreY = positionRefY + stageHeight - MakeInterface.barreHeight - MakeInterface.marge;
		
		_root.BBack._x = barreX;
		_root.BBack._y = barreY;
		_root.BNext._x = barreX + 67;
		_root.BNext._y = barreY;
		_root.BQuitterDiaporama._x = barreX + 131;
		_root.BQuitterDiaporama._y = barreY;
	}
	
	static public function redimentionnerImageFenetre(stageWidth:Number, stageHeight:Number)
	{
		//position de reference
		var positionRefX:Number = MakeInterface.positionRefX(stageWidth);
		var positionRefY:Number = MakeInterface.positionRefY(stageHeight);
		
		//recupere la vignette contenant les infos sur l'image
		var getVignette:Vignette = Vignette.vignetteArray[MakeInterface.currentIdVignette];
		var getImageX:Number = getVignette.getImageX();
		var getImageY:Number = getVignette.getImageY();
		
		//definir le ratio pour l'image
		var getScaleX:Number
		var getScaleY:Number
		
		//definir les dimentions du cadre maximum dans lequel sera affiche l'image
		var imgXMax:Number = stageWidth - 2 * MakeInterface.marge;
		var imgYMax:Number = stageHeight - 3 * MakeInterface.marge - MakeInterface.barreHeight;
		
		//calculer les redimentionnements possibles en x et en y
		getScaleX  = imgXMax / getImageX;
		getScaleY  = imgYMax / getImageY;
		
		//on prend le redimentionnement le plus petit a faire
		if(getScaleX < getScaleY) getScaleY = getScaleX;
		else 					  getScaleX = getScaleY;
		
		//getScaleX  = Math.floor(getScaleX);
		//getScaleY  = Math.floor(getScaleY);
		
		//placement et redimentionnement de l'image a afficher
		_root.afficherImg._x = positionRefX + MakeInterface.marge;
		_root.afficherImg._y = positionRefY + MakeInterface.marge;
		
		//repositionner l'image au centre du cadre
		_root.afficherImg._x += (imgXMax - getImageX*getScaleX) / 2;
		_root.afficherImg._y += (imgYMax - getImageY*getScaleY) / 2;
		
		//multiplier par une facteur 100
		getScaleX *= 100;
		getScaleY *= 100;
		
		//redimentionner l'image
		_root.afficherImg._xscale = getScaleX;
		_root.afficherImg._yscale = getScaleY;
	}
}