﻿class Vignette
{
	public static var vignetteArray:Array = new Array(); //liste contenant toutes les objets vignette
	public static var vignettePosY:Number = 0; //position verticale generale de toutes les vignettes
	private static var vignetteSize:Number = 150; //taille des vignettes
	private static var vignetteHeightSize:Number = 0; //taille total des vignettes en vertical
	static private var imgFileRoot:String; //emplacement des images pour l'interface
	
	private var id:Number; //identifiant unique de la vignette
	
	private var iconeSrc:String; //source de l'icone
	private var imageSrc:String; //source de l'image
	
	private var iconeX:Number; //dimention horizontale de l'icone
	private var iconeY:Number; //dimention verticale de l'icone
	private var imageX:Number; //dimention horizontale de l'image
	private var imageY:Number; //dimention verticale de l'image
	
	private var imageEstChargee:Boolean; //indique si l'image de la vignette est chargee ou non
	
	private var mc:MovieClip;
	private var icone:MovieClip; //icone de l'image
	private var iconeLoad:MovieClip; //animation en attendant de charger l'icone
	private var iconeLoadRotate:MovieClip; //sousClip de iconeLoad
	private var iconeSelect:MovieClip; //cadre de l'icone lorsque celle ci est selectionnee
	private var image:MovieClip; //image
	private var imageLoadMask:MovieClip; //masque necessaire pour les animations du chargement de l'image
	private var imageLoadProgressContainer:MovieClip; //movieClip qui contient l'animation de la barre de progression : imageLoadProgress + imageLoadBackground
	private var imageLoadProgress:MovieClip; //progression du chargement de l'image
	private var imageLoadBackground:MovieClip; //fond de chargement
	
	function Vignette(i:Number, rootHttp:String, interfaceImageFolder:String, myXMLimgs:XMLNode)
	{
		var iconeLoadListener:Object = new Object()
		var imageLoadListener:Object = new Object();
		var loadIconeAnimation:MovieClipLoader = new MovieClipLoader();
		var loadImageAnimation:MovieClipLoader = new MovieClipLoader();
		
		//mettre la vignette dans la liste
		Vignette.vignetteArray.push(this);
		
		this.id = i;
		Vignette.imgFileRoot = rootHttp+interfaceImageFolder;
		
		this.iconeSrc = rootHttp+myXMLimgs.childNodes[i].attributes.icone;
		this.imageSrc = rootHttp+myXMLimgs.childNodes[i].attributes.originale;
		
		this.iconeX = new Number(myXMLimgs.childNodes[i].attributes.iconeX);
		this.iconeY = new Number(myXMLimgs.childNodes[i].attributes.iconeY);
		this.imageX = new Number(myXMLimgs.childNodes[i].attributes.originaleX);
		this.imageY = new Number(myXMLimgs.childNodes[i].attributes.originaleY);
		
		this.imageEstChargee = false;
		
		mc = _root.createEmptyMovieClip("vignette"+i, (i+1000));
		mc._x = 0;
		mc._y = 0;
		
		//l'image de l'icone n'est pas encore chargee, alors on met son alpha a 50%
		mc._alpha = 50;
		
		mc.id = this.id;
		
		mc.onRollOver = function()
		{
			this.iconeSelect._visible = true;
		}
		
		mc.onRollOut = function()
		{
			this.iconeSelect._visible = false;
		}
		
		mc.onPress = function ()
		{
			this.iconeSelect._visible = false;
			
			MakeInterface.modeScene = 1;
			MakeInterface.chargerImage(this.id);
		}
		
		//creer le conteneur de l'icone
		icone = mc.createEmptyMovieClip("icone", 0);
		
		//creer l'animation qui charge l'icone
		iconeLoad = mc.createEmptyMovieClip("iconeLoad", 1);
		
		iconeLoadRotate = iconeLoad.createEmptyMovieClip("iconeLoadRotate", 0);
		
		//lorsque le chargement est fini
		iconeLoadListener.id = this.id;
		iconeLoadListener.onLoadInit = function(holderClip:MovieClip):Void
		{
			var getVignette:Vignette = Vignette.vignetteArray[i];
			
			getVignette.mc.iconeLoad.iconeLoadRotate._x = -15;
			getVignette.mc.iconeLoad.iconeLoadRotate._y = -15;
			
			getVignette.mc.iconeLoad._x = getVignette.iconeX/2;
			getVignette.mc.iconeLoad._y = getVignette.iconeY/2;
			
			getVignette.mc.iconeLoad.onEnterFrame = function()
			{
				getVignette.mc.iconeLoad._rotation += 30;
			}
			
			loadIconeAnimation.removeListener(iconeLoadListener);
		};
		
		loadIconeAnimation.addListener(iconeLoadListener);
		loadIconeAnimation.loadClip(Vignette.imgFileRoot+"/circleProgressBar.png", iconeLoadRotate);
		
		
		//creer le cadre de l'icone lorsque celle ci est selectionnee
		iconeSelect = mc.createEmptyMovieClip("iconeSelect", 2);
		iconeSelect._visible = false;
		
		drawIconeSelectButton(iconeSelect, 5);
		
		//creer le conteneur de l'image
		image = mc.createEmptyMovieClip("image", 3);
		
		//on cree le masque du movieClip imageLoad
		imageLoadMask = mc.createEmptyMovieClip("imageLoadMask", 4);
		
		//creer le movieClip qui contient l'animation de la barre de progression
		imageLoadProgressContainer = mc.createEmptyMovieClip("imageLoadProgressContainer", 5);
		
		//creer l'image de progression du chargement de l'image
		imageLoadProgress = imageLoadProgressContainer.createEmptyMovieClip("imageLoadProgress", 0);
		
		//creer l'image de fond du chargement de l'image
		imageLoadBackground = imageLoadProgressContainer.createEmptyMovieClip("imageLoadBackground", 1);
	}
	
	private function drawIconeSelectButton(selectButton:MovieClip, size:Number)
	{
		//bord du haut
		selectButton.beginFill(0x999999, 100);
		selectButton.moveTo(-size          , -size);
		selectButton.lineTo( size + iconeX , -size);
		selectButton.lineTo( size + iconeX , 0);
		selectButton.lineTo(-size          , 0);
		selectButton.endFill();
		
		//bord du bas
		selectButton.beginFill(0x999999, 100);
		selectButton.moveTo(-size          , iconeY);
		selectButton.lineTo( size + iconeX , iconeY);
		selectButton.lineTo( size + iconeX , iconeY + size);
		selectButton.lineTo(-size          , iconeY + size);
		selectButton.endFill();
		
		//bord a gauche
		selectButton.beginFill(0x999999, 100);
		selectButton.moveTo(-size , 0);
		selectButton.lineTo(-size , iconeY);
		selectButton.lineTo( 0    , iconeY);
		selectButton.lineTo( 0    , 0);
		selectButton.endFill();
		
		//bord a droite
		selectButton.beginFill(0x999999, 100);
		selectButton.moveTo( size + iconeX , 0);
		selectButton.lineTo( size + iconeX , iconeY);
		selectButton.lineTo( iconeX        , iconeY);
		selectButton.lineTo( iconeX        , 0);
		selectButton.endFill();
	}
	
	public function getImageX():Number
	{
		return imageX;
	}
	
	public function getImageY():Number
	{
		return imageY;
	}
	
	static public function chargerIcone(i:Number)
	{
		var getVignette:Vignette = Vignette.vignetteArray[i];
		
		//on verifie que l'objet selectionne dans la liste n'est pas vide
		if(getVignette != undefined)
		{
			var loaderListener:Object = new Object()
			var loadIcone:MovieClipLoader  = new MovieClipLoader();
			
			//lorsque le chargement est fini
			loaderListener.onLoadInit = function(holderClip:MovieClip):Void
			{
				//on retire l'animation de chargement de l'icone
				getVignette.mc.iconeLoad.iconeLoadRotate.onEnterFrame = undefined;
				getVignette.mc.iconeLoad.iconeLoadRotate.removeMovieClip();
				getVignette.mc.iconeLoad.onEnterFrame = undefined;
				getVignette.mc.iconeLoad.removeMovieClip();
				
				//recurence : on continue a charger la prochaine icone
				Vignette.chargerIcone(i+1);
				
				loadIcone.removeListener(loaderListener);
			};
			
			//si il y a une erreur (principalement une erreur de serveur), on force le chargement de l'icone en rechargeant l'icone
			loaderListener.onLoadError = function(target_mc:MovieClip, errorCode:String)
			{
				Vignette.chargerIcone(i);
			}
			
			loadIcone.addListener(loaderListener);
			loadIcone.loadClip(getVignette.iconeSrc, getVignette.icone);
		}
	}
	
	static public function chargerImage(i:Number)
	{
		var getVignette:Vignette = Vignette.vignetteArray[i];
		
		//on verifie que l'objet selectionne dans la liste n'est pas vide
		if(getVignette != undefined)
		{
			//on verifie que l'image n'est pas deja chargee
			if(getVignette.imageEstChargee == true)
			{
				//si oui, on passe au chargement de l'image suivante
				Vignette.chargerImage(i+1);
			}
			else
			{
				//si non, on cree la barre qui charge les images
				
				//on charge la barre de fond de chargement
				var backgroundLoaderListener:Object = new Object();
				var backgroundLoadImage:MovieClipLoader  = new MovieClipLoader();
				
				//lorsque le chargement est fini
				backgroundLoaderListener.onLoadInit = function(holderClip:MovieClip):Void
				{
					//l'image de l'icone est chargee, alors on met son alpha a 100%
					getVignette.mc._alpha = 100;
					
					//on applique le masque sur le moviclip qui contient la barre d'animation et qui est a la taille de l'icone
					getVignette.mc.imageLoadMask.beginFill(0x000000, 100);
					getVignette.mc.imageLoadMask.moveTo(0 , 0);
					getVignette.mc.imageLoadMask.lineTo(getVignette.iconeX, 0);
					getVignette.mc.imageLoadMask.lineTo(getVignette.iconeX, 10);
					getVignette.mc.imageLoadMask.lineTo(0 , 10);
					getVignette.mc.imageLoadMask.endFill();
					
					getVignette.mc.imageLoadProgressContainer.setMask(getVignette.mc.imageLoadMask);
					
					//on charge la barre de progression
					var progressLoaderListener:Object = new Object();
					var progressLoadImage:MovieClipLoader  = new MovieClipLoader();
					
					//lorsque le chargement est fini
					progressLoaderListener.onLoadInit = function(holderClip:MovieClip):Void
					{
						//on cree l'animation de la barre
						getVignette.mc.imageLoadProgressContainer.imageLoadProgress.onEnterFrame = function()
						{
							getVignette.mc.imageLoadProgressContainer.imageLoadProgress._x --;
							if(getVignette.mc.imageLoadProgressContainer.imageLoadProgress._x <= -16) getVignette.mc.imageLoadProgressContainer.imageLoadProgress._x = 0;
						}
						
						//on charge l'image
						var loaderListener:Object = new Object();
						var loadImage:MovieClipLoader  = new MovieClipLoader();
						
						//mettre a jour les donnees
						loaderListener.onLoadProgress = function(holderClip:MovieClip, loadedBytes:Number, totalBytes:Number):Void
						{
							var percent:Number = loadedBytes / totalBytes;
							getVignette.mc.imageLoadProgressContainer.imageLoadBackground._x = Math.round(percent * getVignette.iconeX);
						};
						
						//lorsque le chargement est fini
						loaderListener.onLoadInit = function(holderClip:MovieClip):Void
						{
							//on rend l'image chargee invisible
							getVignette.image._visible = false;
							
							//on indique que l'image est bien chargee en cache
							getVignette.imageEstChargee = true;
							
							//on retire l'animation de chargement de l'image
							getVignette.mc.imageLoadBackground.removeMovieClip();
							getVignette.mc.imageLoadProgress.onEnterFrame = undefined;
							getVignette.mc.imageLoadProgress.removeMovieClip();
							getVignette.mc.imageLoadMask.removeMovieClip();
							getVignette.mc.imageLoadProgressContainer.removeMovieClip();
							
							loadImage.removeListener(loaderListener);
							
							//recurence : on continue a charger la prochaine image
							Vignette.chargerImage(i+1);
						};
						
						//si il y a une erreur (principalement une erreur de serveur), on force le chargement de l'image en rechargeant l'image
						loaderListener.onLoadError = function(target_mc:MovieClip, errorCode:String)
						{
							Vignette.chargerImage(i);
						}
						
						loadImage.addListener(loaderListener);
						loadImage.loadClip(getVignette.imageSrc, getVignette.image);
						
						progressLoadImage.removeListener(progressLoaderListener);
					};
					
					progressLoadImage.addListener(progressLoaderListener);
					progressLoadImage.loadClip(Vignette.imgFileRoot+"/smallProgressBar2.png", getVignette.imageLoadProgress);
					
					backgroundLoadImage.removeListener(backgroundLoaderListener);
				};
				
				backgroundLoadImage.addListener(backgroundLoaderListener);
				backgroundLoadImage.loadClip(Vignette.imgFileRoot+"/smallProgressBar1.png", getVignette.imageLoadBackground);
			}
		}
	}
	
	static public function ajusterIcones(stageWidth:Number, stageHeight:Number)
	{
		var getMC:MovieClip;
		
		//position de reference
		var positionRefX:Number
		var positionRefY:Number
		//calculer le nombre de vignette par ligne dans la fenetre
		var nbVignetteX:Number = Math.floor(stageWidth / Vignette.vignetteSize);
		//calculer le nombre de vignette par colonne dans la fenetre
		var nbVignetteY:Number = Math.floor(stageHeight / Vignette.vignetteSize);
		//calculer la taille des vignettes sur une ligne
		var vignetteXSize:Number = Vignette.vignetteSize*nbVignetteX;
		//calculer la taille restante horizontale libre des vignettes
		var freeXSize:Number = stageWidth - nbVignetteX * Vignette.vignetteSize;
		//calculer la taille restante verticale libre des vignettes
		var freeYSize:Number = stageHeight - nbVignetteY * Vignette.vignetteSize;
		//calculer l'espace horizontal entre les vignettes
		var spaceXSize:Number = Math.floor(freeXSize/(nbVignetteX+1));
		//calculer l'espace vertical entre les vignettes
		var spaceYSize:Number = Math.floor(freeYSize/(nbVignetteY+1));

		var iVignetteSize:Number;
		var iVignettePosX:Number;
		var iVignettePosY:Number;
		var i:Number;
		
		//corriger le deplacement pour placer les vignettes en haut a gauche
		positionRefX = Math.round((MakeInterface.originalStageWidth - stageWidth)/2);
		positionRefY = Math.round((MakeInterface.originalStageHeight - stageHeight)/2);
		
		//la position horizontale depend du mode
		positionRefX -= stageWidth * MakeInterface.modeScene;
		
		//la position verticale est fonction de la position verticale generale
		positionRefY += Vignette.vignettePosY;
		
		//position des boutons du haut
		var buttonX:Number;
		var buttonY:Number;
		
		//position du bouton "telechargement manuel" en haut a gauche
		buttonX = _root.BDownload._width;
		buttonY = _root.BDownload._height;
		
		_root.BDownload._x = positionRefX + Math.round(stageWidth/2 - buttonX/2);
		_root.BDownload._y = positionRefY + Math.round((Vignette.vignetteSize - buttonY)/2);
		
		//on laisse un peu de place pour afficher les boutons du haut
		positionRefY += Vignette.vignetteSize;
		
		//position des vignettes
		for (i = 0; i < Vignette.vignetteArray.length; i++)
		{
			getMC = Vignette.vignetteArray[i].mc;
			//taille de la ligne des vignettes
			iVignetteSize = i * Vignette.vignetteSize;
			//numero de la position horizontale de la vignette
			iVignettePosX = i % nbVignetteX;
			//numero de la position verticale de la vignette
			iVignettePosY = Math.floor(iVignetteSize/vignetteXSize);
			
			//prendre la position de reference
			getMC._x = positionRefX;
			getMC._y = positionRefY;
			
			//deplacer les vignettes en fonction de la fenetre
			getMC._x += iVignetteSize % vignetteXSize;
			getMC._y += iVignettePosY * Vignette.vignetteSize;
			
			//centrer l'icone dans la vignette
			getMC._x += Math.round(Vignette.vignetteSize/2);
			getMC._y += Math.round(Vignette.vignetteSize/2);
			
			getMC._x -= Math.round(Vignette.vignetteArray[i].iconeX/2);
			getMC._y -= Math.round(Vignette.vignetteArray[i].iconeY/2);
			
			//occuper tout l'espace horizontal de la fenetre
			getMC._x += spaceXSize * (iVignettePosX + 1);
			
			//occuper tout l'espace vertical de la fenetre
			getMC._y += spaceYSize * (iVignettePosY + 1);
		}
		
		//mettre a jour la taille totale des vignettes en vertical
		Vignette.vignetteHeightSize = (iVignettePosY + 3) * Vignette.vignetteSize;
		Vignette.vignetteHeightSize += spaceYSize * (iVignettePosY + 1);
	}
	
	static public function mouseMoveVignette(stageWidth:Number, stageHeight:Number, mouseY:Number)
	{
		var deltaY:Number;
		var limitDownMax:Number;
				
		//corriger la position en fonction de la taille de la fenetre
		mouseY += Math.round((stageHeight - MakeInterface.originalStageHeight)/2);
		
		//calculer le delta vertical par rapport au milieu de la scene
		deltaY = Math.round(stageHeight/2 - mouseY);
		//transformer mathematiquement le delta pour rendre le mouvement plus fluide
		deltaY = Math.round(Math.pow(deltaY / 100, 3));
		
		Vignette.vignettePosY += deltaY;
		
		//delimiter l'espace de mouvement en haut
		if(Vignette.vignettePosY > 0) Vignette.vignettePosY = 0;
		
		//delimiter l'espace de mouvement en bas
		limitDownMax = - Vignette.vignetteHeightSize + stageHeight;
		if(limitDownMax > 0) limitDownMax = 0;
		
		if(Vignette.vignettePosY < limitDownMax) Vignette.vignettePosY = limitDownMax;
		
		Vignette.ajusterIcones(stageWidth, stageHeight);
	}
}